# $Id: drawstatus.tcl,v 1.1 1996/11/17 14:53:48 uwe Exp $
#
# trace output

proc errormessage text {
    global argv0

    puts stderr "$argv0: $text"
    exit 1
}

proc message text {
    global puzzle

    if {! $puzzle(drawStatus)} return
    puts stderr $text
}

proc drawStatus {} {
    global puzzle

    if {! $puzzle(drawStatus)} return

    set w $puzzle(window)

    message "drawStatus --> [list $puzzle(currField) $puzzle(currOrg) $puzzle(currStart) $puzzle(currRot)]"

    # draw current field

    catch {$w delete $puzzle(field)}

    set p0 [eval scaleVec $puzzle(currField) $puzzle(fieldSize)]
    set p1 [eval addVec $p0 [list $puzzle(fieldSize) $puzzle(fieldSize)]]

    set puzzle(field) \
	[eval [list $w create rectangle] $p0 $p1 [list -fill {} -outline black]]

    # draw current origin
    catch {$w delete $puzzle(org)}
    set p0 [eval addVec $puzzle(currOrg) [list -1 -1]]
    set p1 [eval addVec $puzzle(currOrg) [list  1  1]]
    
    set puzzle(org) \
	[eval [list $w create oval] $p0 $p1 [list -fill red -outline red]]

    #draw current start point
    catch {$w delete $puzzle(start)}

    set p0 [eval addVec $puzzle(currStart) [list -1 -1]]
    set p1 [eval addVec $puzzle(currStart) [list  1  1]]

    set puzzle(start) \
	[eval [list $w create oval] $p0 $p1 [list -fill blue -outline blue]]

    #draw current picture point
    catch {$w delete $puzzle(pic)}

    set pp [eval rotBy90xN [list 42 42] $puzzle($puzzle(currField))]
    set pp [eval addVec $pp $puzzle(currOrg)]
    
    set p0 [eval addVec $pp [list -5 -5]]
    set p1 [eval addVec $pp [list  5  5]]

    set puzzle(pic) \
	[eval [list $w create oval] $p0 $p1 [list -fill green -outline blue]]
}
