# $Id: evaloptions.tcl,v 1.2 1996/11/17 17:08:27 uwe Exp $
#
# program options evaluation

proc options args {
    global puzzle argv0

    setopt help no
    if {"$help" != "no"} {
	errormessage " usage
$argv0 \[ -size <field-size> \] \[ -picture <picture-file> \] \[ -debug <on/off> \] \[ -help \]
"
    }

    setopt size 200
    if {[catch {set size [expr int($size)]}] \
	    || $size < 10 \
	    || $size > 500} {
	errormessage "value for -size must be in range 10..500"
    }
    set puzzle(fieldSize) $size

    setopt picture "puzzle"
    # only the 1. picture file is tested: not save !!!
    if {! [file isfile "$picture-0.gif"]} {
	errormessage "picture file not found: $picture-0.gif"
    }
    setopt puzzle(pictureFile) $picture

    setopt debug off
    set puzzle(debug)	0
    if {"$debug" == "on"} {
	set puzzle(debug) 1
    }

    set puzzle(puzzleSize)	3
    set puzzle(canvasSize)	[expr $puzzle(fieldSize) *  $puzzle(puzzleSize)]
    set puzzle(window)		.puzzle
    set puzzle(drawStatus)	0
}

