# $Id: preparepictures.tcl,v 1.1 1996/11/17 14:53:49 uwe Exp $
#
# prepare pictures

proc preparePictures {} {
    global puzzle

    set puzzle(MakeRules) {}
    set puzzle(MakeTargets)  {}

    forallFields makeRule

    set Makefile "
all : $puzzle(MakeTargets)

$puzzle(MakeRules)
"
    set makefile "Makefile-[pid]"

    catch {exec cat << $Makefile > $makefile}
    set rc [catch {exec make -f $makefile all} log]
    catch {exec rm $makefile}

    message "preparePictures: make rc: $rc\n$log"
}

proc makeRule {ix args} {
    global puzzle

    set file $puzzle(pictureFile)
    set size $puzzle(fieldSize)
    set nr [expr [lindex $ix 0] * $puzzle(puzzleSize) + [lindex $ix 1]]

    append puzzle(MakeRules) "
$file-$nr-$size-0.gif : $file-$nr.gif
	cat \$? | giftopnm | pnmscale -xysize $size $size | ppmquant 256 | ppmtogif > \$@

$file-$nr-$size-1.gif : $file-$nr-$size-0.gif
	cat \$? | giftopnm | pnmflip -rotate90 | ppmtogif > \$@

$file-$nr-$size-2.gif : $file-$nr-$size-1.gif
	cat \$? | giftopnm | pnmflip -rotate90 | ppmtogif > \$@

$file-$nr-$size-3.gif : $file-$nr-$size-2.gif
	cat \$? | giftopnm | pnmflip -rotate90 | ppmtogif > \$@
"

    append puzzle(MakeTargets) " \
$file-$nr-$size-0.gif $file-$nr-$size-1.gif $file-$nr-$size-2.gif $file-$nr-$size-3.gif"

}

